﻿/*
drop table Osoba;
go

create table Osoba
(
	ID int primary key identity,
	Imie varchar(30) not null,
	Nazwisko varchar(50) not null,
	UlicaDom varchar(100),
	MiastoDom varchar(100),
	UlicaPraca varchar(100),
	MiastoPraca varchar(100)
)
go
*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NHibernate.Cfg;
using NHibernate.Mapping.Attributes;
using NHibernate;
using System.Reflection;

namespace UsingComponentsAttributes
{
    class Program
    {
        static void Main( string[] args )
        {
            Configuration cfg = new Configuration();
            cfg.Configure();
            HbmSerializer.Default.Validate = true; // Opcjonalne
            // Here, we serialize all decorated classes (but you can also do it class by class)
            cfg.AddInputStream( HbmSerializer.Default.Serialize( Assembly.GetExecutingAssembly() ) );

            ISessionFactory f = cfg.BuildSessionFactory();
            using ( ISession s = f.OpenSession() )
            {
                Osoba o = new Osoba { Imie = "Jan", Nazwisko = "Kowalski",
                    DomowyAdres = new Adres { Ulica = "Boya", Miasto = "Wrocław" },
                    SluzbowyAdres = new Adres { Ulica = "Boya", Miasto = "Wrocław" }
                };
                s.Save( o );
                s.Flush();
                s.Close();
            }

            using ( ISession s = f.OpenSession() )
            {
                IList<Osoba> lista = s.CreateQuery( "from Osoba o order by o.Nazwisko" ).List<Osoba>();
                foreach ( var o in lista )
                    Console.WriteLine( "{0} {1}, {2} {3}", o.Nazwisko, o.Imie, o.DomowyAdres.Miasto, o.DomowyAdres.Ulica );
                s.Close();
            }
        }
    }
}
